<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="视频编号" prop="code">
        <el-input
          v-model="queryParams.code"
          placeholder="请输入视频编号"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select
          v-model="queryParams.type"
          placeholder="请选择类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SAFE_CAMERA_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="后端设备" prop="serverId">
        <el-select
          v-model="queryParams.serverId"
          placeholder="请选择后端设备"
          clearable
          class="!w-300px"
        >
          <el-option
            v-for="server in serverList"
            :key="server.id"
            :label="server.name"
            :value="server.id"
        >
            <span style="float: left">{{ server.name }}</span>
            <span
              style="
                float: right;
                color: var(--el-text-color-secondary);
                font-size: 10px;
              "
            >
              {{ server.protocol +'://'+server.ip+':'+server.port+'/'+server.domain }}
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['safe:camera:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['safe:camera:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="视频编号" align="center" prop="code" />
      <el-table-column label="类型" align="center" prop="type">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.SAFE_CAMERA_TYPE" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="后端设备" align="center" prop="serverId" >
        <template #default="scope">
          {{ serverMap.get(scope.row.serverId) }}
        </template>
      </el-table-column>
      <el-table-column label="AI模型" align="center" prop="aiMode">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.SAFE_AI_MODE" :value="scope.row.aiMode" />
        </template>
      </el-table-column>
      <el-table-column label="报警状态" align="center" prop="warn">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.warn" />
        </template>
      </el-table-column>
      <el-table-column label="报警接口" align="center" prop="warnApi" />
      <el-table-column label="描述" align="center" prop="des" />
      <el-table-column label="操作" align="center">
        <template #default="scope">
          <div class="flex items-center justify-center">
            <el-button
              link
              type="success"
              @click="openView(scope.row.id)"
              v-hasPermi="['safe:camera:query']"
            >
            <Icon icon="ep:camera" /> 预览
            </el-button>
            <el-button
              link
              type="primary"
              @click="openForm('update', scope.row.id)"
              v-hasPermi="['safe:camera:update']"
            >
            <Icon icon="ep:edit" /> 编辑
            </el-button>
            <el-button
              link
              type="danger"
              @click="handleDelete(scope.row.id)"
              v-hasPermi="['safe:camera:delete']"
            >
            <Icon icon="ep:delete" /> 删除
            </el-button>
          </div>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CameraForm ref="formRef" @success="getList" />
  <CameraView  ref="viewRef"/>
</template>

<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import download from '@/utils/download'
import { CameraApi, CameraVO } from '@/api/safe/camera'
import { ServerApi } from '@/api/safe/server'
import CameraForm from './CameraForm.vue'
import CameraView from './CameraView.vue'

/** 安防前端设备 列表 */
defineOptions({ name: 'SafeCamera' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<CameraVO[]>([]) // 列表的数据
let serverList = ref([])//后端设备列表
const serverMap = new Map()//后端设备映射字典
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  name: undefined,
  code: undefined,
  type: undefined,
  serverId: undefined,
  des: undefined,
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await CameraApi.getCameraPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 预览操作 */
const viewRef = ref()
const openView = (id?: number) => {
  viewRef.value.open(id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CameraApi.deleteCamera(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CameraApi.exportCamera(queryParams)
    download.excel(data, '安防前端设备.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(async () => {
  await getList()
  // 查询流程分类列表
  serverList.value = await ServerApi.getAllServer()
  serverMap.clear
  if(serverList){
    serverList.value.forEach(it =>{
      serverMap.set(it.id, it.name)
    })
  }
})
</script>